package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.HubunganKeluarga;
import com.jasamedika.medifirst2000.vo.HubunganKeluargaVO;

@Component
public class HubunganKeluargaConverter implements BaseVoConverter<HubunganKeluargaVO, HubunganKeluarga> {


	@Override
	public HubunganKeluarga transferVOToModel(HubunganKeluargaVO vo, HubunganKeluarga model) {
		if (null == model)
			model = new HubunganKeluarga();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, HubunganKeluarga.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<HubunganKeluargaVO> transferListOfModelToListOfVO(List<HubunganKeluarga> models, List<HubunganKeluargaVO> vos) {

		if (null == vos)
			vos = new ArrayList<HubunganKeluargaVO>();

		if (null == models)
			return vos;

		for (HubunganKeluarga HubunganKeluarga : models) {
			HubunganKeluargaVO vo = new HubunganKeluargaVO();
			vo=transferModelToVO(HubunganKeluarga, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public HubunganKeluargaVO transferModelToVO(HubunganKeluarga model, HubunganKeluargaVO vo) {
		if (null == vo)
			vo = new HubunganKeluargaVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
	        Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, HubunganKeluargaVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	
	
	

}
